/* EII for Plane wave model */

#include <stream.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "weeks.h"
#include "beom.h"


complex Zeii(complex si,complex Ref,complex gamma,double wid,double th, 
	double x,double y,int ind)
{
  complex J=r2c(0.,1.);
  static double mu=1.257e-6;
  complex Hx,Hy,Ez,Z;

  Hx=(cexp(gamma*(-y))-cexp(gamma*(y-th))-Ref*(cexp(gamma*(y-2.*th))-
	cexp(gamma*(-(y+th)))))/(1.-Ref*cexp(-2.*gamma*th));
  Hy=(-1.*cexp(gamma*(-x))+cexp(gamma*(x-wid))+Ref*(cexp(gamma*(x-2.*wid))-
	cexp(gamma*-(x+wid))))/(1.-Ref*cexp(-2.*gamma*wid));
  Ez=si*((cexp(gamma*(-y))+cexp(gamma*(y-th))+Ref*
	(cexp(gamma*(y-2.*th))+cexp(gamma*(-y-th))))/(1.-Ref*cexp(-2.*gamma*th))
	+(cexp(-1.*gamma*x)+cexp(gamma*(x-wid))+Ref*(cexp(gamma*(x-2.*wid))
	+cexp(-1*gamma*(x+wid))))/(1.-Ref*cexp(-2.*gamma*wid)));
  if (ind==0) Z=Ez/Hx;    //top or bottom
  else Z=(-1*Ez/Hy);  //sides
  return Z;
}
  

complex Zs(double w,Conductor *c,double x1,double x2,double y1,double y2,
	int pos)
{
  double mu=1.257e-6;
  double ep=8.854e-12;
  complex J=r2c(0.,1.);
  double skin,th,wid,x,y,th2;
  complex gamma,Ref,ro,rm,Z,temp;
  skin=sqrt(2./(w*mu*c->si));
  if (x2 > x1) {
    x1-=c->x1; x2-=c->x1; y1-=c->y1; y2-=c->y1; x=(x1+x2)/2.; y=(y1+y2)/2.;
  }
  else {
    x1-=c->x2; x2-=c->x2; y1-=c->y2; y2-=c->y2; x=(x1+x2)/2.; y=(y1+y2)/2.;
  }
  wid=fabs(c->x2-c->x1);
  th=fabs(c->y2-c->y1);
  th2=th*2.;
  gamma=cpow((J*w*mu*(c->si+J*w*ep)),0.5);
  temp=cpow((J*w*mu/c->si),0.5);
  ro=r2c(sqrt(mu/ep),0.);
  rm=cpow((J*w*mu/c->si),0.5);
  Ref=(ro-rm)/(ro+rm);
  if (pos==0) Z=Zeii(temp,Ref,gamma,wid,th,x,0.,pos);
  else Z=Zeii(temp,Ref,gamma,wid,th,0.,y,pos);
  return Z;
} 


complex Zcir(double w,Conductor* c)
{
  return Zscir(w,c->rad,c->si)/(2*M_PI*c->rad/c->nr);
}

complex Ztrap(double w,Conductor*c,int ind)
{
  return Zstrap(w,c->si,c->x1,c->x2,c->y1,c->y2,ind);
}

complex Zplt(double w,Conductor *c,int ind)
{
  double t;
  if (ind==1) t=fabs(c->y2-c->y1);
  else t=fabs(c->y2-c->y1)/2.;
  return Zsplt(w,t,c->si);
}


complex ZsBTL(double w,Conductor* c,double x1,double x2,double y1,double y2)
{
  double x,x1b,x2b,y1b,y2b;
  double si;
  si=c->si;

  if (fabs(x1-x2) > fabs(y1-y2)) {
    x=.5*(x1+x2);
    x1b=c->x1;
    x2b=c->x2;
    y1b=c->y1;
    y2b=c->y2;
  }
  else {
    x=.5*(y1+y2);
    x1b=c->y1;
    x2b=c->y2;
    y1b=c->x1;
    y2b=c->x2;
  }
  return Zsbeom(w,x1b,y1b,x2b,y2b,x,si);
}

