/* incident matrix setup and swapping ymtrx */
#include "weeks.h"
#include "../include/linear.h"
#include <stdio.h>

extern complex** ymtrx;

complex **Zequ(Conductor *c,int numsgn,int Nc)
{
  complex **A,**B,**C,**D,**Din;
  Conductor *iC;
  int i,j,k;
  complex tot;
  int grd;

  A=matrix(numsgn+1,Nc);
  B=matrix(numsgn+1,Nc);
  C=matrix(Nc,numsgn+1);
  D=matrix(numsgn+1,numsgn+1);
  Din=matrix(numsgn+1,numsgn+1);

  for (i=0; i<numsgn+1; i++)
    for (j=0; j<Nc; j++) A[i][j]=r2c(0.,0.);

  iC=c;
  int cnt=0;
  grd=0;
  for (i=0;i<Nc;i++) {
    if (iC->Grd==0) {
      A[numsgn][i]=r2c(-1.,0.);
      cnt+=1;
    }
    else {
      A[i-cnt][i]=r2c(1.,0.);
      A[numsgn][i]=r2c(-1,0.);
    }
    iC=iC->next;
  }

  for (i=0; i<numsgn+1; i++) {
    for (j=0; j<Nc; j++) {
      tot=r2c(0.,0.);
      for (k=0; k<Nc; k++) tot=tot+(A[i][k]*ymtrx[k][j]);
      B[i][j]=tot;
      C[j][i]=A[i][j]; /* transpose of A */
    }
  }
  for (i=0; i<numsgn+1; i++) {
    for (j=0; j<numsgn+1; j++) {
      tot=r2c(0.,0.);
      for (k=0; k<Nc; k++) tot=tot+(B[i][k]*C[k][j]);
      D[i][j]=tot;
    }
  }
  Din=inverse(D,numsgn+1);
/*
  delete A;
  delete B;
  delete C;
  delete D;
*/
  return Din;
}

void ysort(int Nc,int n,int m)
{
  int i,j;
  complex **ys;
  ys=matrix(Nc,Nc);

  for (i=0; i<Nc; i++) {
    for (j=0; j<Nc; j++) {
      if (i!=n && i!=m && j!=n && j!=m) ys[i][j]=ymtrx[i][j];
      else if (i==j) {
        if (i==n) ys[i][i]=ymtrx[m][m];
        else if (i==m) ys[i][i]=ymtrx[n][n];
      }
      else if ((i==n && j==m) || (i==m && j==n)) ys[i][j]=ymtrx[i][j];
      else {
        if (i==n) ys[i][j]=ymtrx[m][j];
        else if (i==m) ys[i][j]=ymtrx[n][j];
        else if (j==n) ys[i][j]=ymtrx[i][m];
        else if (j==m) ys[i][j]=ymtrx[i][n];
        else printf("damn\n");
      }
    }
  }
  for (i=0; i<Nc; i++) 
    for (j=0; j<Nc; j++) ymtrx[i][j]=ys[i][j];
  delete ys;
}      

  
