/* Main program, prints out all the results */
/* written and modified by Emre Tuncer and Sangwoo Kim */
#include <fstream.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <time.h>
#include "weeks.h"
#include "reader.h"
#include "filament.h"
#include "inductance.h"
#include "conductor.h"
#include "plane.h"
#include "../include/linear.h"
#include "incident.h"

complex **ymtrx;
Sys *sis;
 
main(int argc,char** argv)
{
  int condition=0;
  FILE *fo,*fi,*fzs;
  Filament* gnd;
  Filament *iF,*jF;
  Conductor *iC;
  Conductor *jC;
  complex** Din; 
  complex** ys;
  complex** Z;          //matrix for filament impedance
  complex** Y;          //matrix for filament admittance 
  complex** z;
  complex **tmp;
  complex **intmp;
  double** L;
  double LpGnd,w;
  int Nf,Nc,numgrd,numsgn;
  int i,j,k,l;
  int iw,grd;
  double d;
  time_t start,stop,middle;
  printf("\n");
  start=time(NULL);
  if (argc!=3) {
    cerr << "Usage: " << argv[0] << 
      " <input file> <w/r>\n";
    exit(1);
  }
  Conductor *cons;
  Filament *fils;
  sis = new Sys;
  cons=new Conductor;
  fils=new Filament;
  printf("\n");

//  if (argv[2][0]=='w') {
    reader(cons,sis,argv[1]);
    if (sis->pc != 0) filplane(cons);
//  }

/*
  if (((sis->pc!=0)&&(condition==0))&&(argv[2][0]=='w')) {
    condition=1;
    reader(cons,sis,argv[1]);
    filplane(cons);
  }
*/
  if (sis->loop==0) grd=GRD(cons,&numgrd,&numsgn);

  int *nf=new int[sis->pc+sis->lc+2];
  filamentor(cons,fils,nf);
  Nc=sis->pc+sis->lc;
  Nf=nf[Nc+1];
  LastFil(fils);         //remove last empty entry. 
//  Corr(fils); /* x1 < x2 */
  printf("Total %ld ribbons, %ld conductor\n",Nf,Nc);
  L=allocator(Nf);

  if (argv[2][0]=='w') {
    fo=fopen("induc","w");
    iF=fils;
    for (i=0;i<Nf;i++) {
      jF=iF;
      for (j=i;j<Nf;j++) {
	L[j][i]=L[i][j]=Lp(iF,jF); 
	jF=jF->next;
        fprintf(fo,"%ld %ld %le\n",i,j,L[i][j]*sis->unit);
      }
      iF=iF->next;
    }
    fclose(fo);
    delete iF;
    delete jF;
  }
  else {
    fi=fopen("induc","r");
    for (i=0;i<Nf;i++) {
      for (j=i;j<Nf;j++) {
        fscanf(fi,"%ld  %ld  %le\n",&k,&k,&L[i][j]); 
        L[i][j]/=sis->unit;
        L[j][i]=L[i][j];
      }
    }
    fclose(fi);
  }
  fzs=fopen("Zs","w");
  for (iw=0;iw<=sis->NofF;iw++) {
    if (iw< sis->NofF)
	w=2*M_PI*sis->stFreq*exp(iw*log(sis->spFreq/sis->stFreq)/sis->NofF);
    else if ((iw==sis->NofF)&&(sis->NofF!=1)) 
	w=2*M_PI*sis->spFreq;
    else if ((sis->NofF==1)&&(iw==1)) {
      fclose(fzs);
      stop= time(NULL);
      printf("\n");
      printf("***********  \n");
      printf("Total Elapsed time=%ld Seconds\n",(stop-start)); 
      exit(1);
    }
    Z=matrix(Nf,Nf);
    for (i=0;i<Nf;i++)  
      for (j=i;j<Nf;j++) 
	Z[i][j]=Z[j][i]=r2c(0.,w*L[i][j]);
    iF=fils;    
    for (i=0;i<Nf;i++) {
      Z[i][i]=Z[i][i]+iF->zs(w);
      iF=iF->next;
    }
    Y=matrix(Nf,Nf);
    Y=inverse(Z,Nf);

    ymtrx=matrix(Nc,Nc);

    for (k=0;k<Nc;k++) {
      for (l=0;l<Nc;l++) {
	ymtrx[k][l]=r2c(0.,0.);
	for (i=nf[k+1];i<nf[k+2];i++) 
	  for (j=nf[l+1];j<nf[l+2];j++) 
	    ymtrx[k][l]=ymtrx[k][l]+Y[i][j];
      }
    }

    if ((sis->loop != 0) || (Nc==1)){
      z=matrix(Nc,Nc);
      z=inverse(ymtrx,Nc);
      fprintf(fzs,"\nImpedance %ld x %ld matrix (R,L) at f=%10.4le Hz\n",
	Nc,Nc,w/2/M_PI);
      for (i=0;i<Nc;i++) {
        for (j=0;j<Nc;j++) {
          fprintf(fzs,"(%11.4le,%11.4le)  ",RE(z[i][j])*sis->unit,IM(z[i][j])
	/w*sis->unit);
        } 
        fprintf(fzs,"\n");
      }
    }
    else {
      /* let's swap y matrix so that grd goes last matrix position */
      grd=GRD(cons,&numgrd,&numsgn);
      iC=cons;
      for (i=0; i<Nc; i++) {
        if (iC->Grd != 0) iC=iC->next;
        else {
          jC=iC;
          k=0; 
          for (j=i; j<Nc; j++) {
            if (jC->Grd !=0) {
              k=j;  /* k is sgn, i is grd */
              jC->Grd=0;
              break;
            }
            jC=jC->next;
          }
          if (k != 0) {
            ysort(Nc,k,i);
            iC->Grd=1;
          }
          k=0;
          iC=iC->next;
        }
      }

      Din=matrix(numsgn+1,numsgn+1);
      Din=Zequ(cons,numsgn,Nc);
      fprintf(fzs,"\nImpedance %ld x %ld matrix (R,L) at f=%10.4le Hz\n",
	numsgn,numsgn,w/2/M_PI);

      for (i=0;i<numsgn;i++) {
        for (j=0;j<numsgn;j++) {
          fprintf(fzs,"(%11.4le,%11.4le)  ",RE(Din[i][j])*sis->unit,IM(Din[i][j])
 	       /w*sis->unit);
        }
        fprintf(fzs,"\n");
      }
      delete iC;
      delete jC;
    }
  }
  fclose(fzs);
  stop= time(NULL);
  printf("\n");
  printf("***********  \n");
  printf("Total Elapsed time=%ld Seconds\n",(stop-start));  
  exit(0);
}

