/* Ribbon segmentation on ground plane */
#include <math.h>
#include <stdio.h>
#include "weeks.h"
#include "plane.h"
#include "../include/linear.h"

extern Sys *sis;


double geth(double a,double b,double c,double d)
{
  double temp;
  temp=fabs(b-d);
  if (temp >= fabs(b-c)) temp=fabs(b-c);
  if (temp >= fabs(a-c)) temp=fabs(a-c);
  if (temp >= fabs(a-d)) temp=fabs(a-d);
  return temp;
}


void bubble(double a[],int n) {
  int i,j,k;
  double temp1;
  for (i=1;i<=n;i++) {
  temp1=1e10;
    for (j=i;j<= n;j++) {
      if (temp1 > a[j]) {
        temp1=a[j];
        k=j;
      }
    }
    a[k]=a[i];
    a[i]=temp1;
  }
}

void b_bubble(double a[],int n) {
  int i,j,k;
  double temp1;
  for (i=1;i<=n;i++) {
  temp1=(-1e10);
    for (j=i;j<= n;j++) {
      if (temp1 < a[j]) {
        temp1=a[j];
        k=j;
      }
    }
    a[k]=a[i];
    a[i]=temp1;
  }
}

int GRD(Conductor *c,int *numgrd,int *numsgn)
{
  int cnt;
  int wgrd;

  cnt=0;
  *numgrd=0;
  *numsgn=0;
  while (c != NULL) {
    if (fabs(c->v) < 1e-10) {
      wgrd=cnt;
      c->Grd=0;
      *numgrd+=1; 
    } 
    else {
      c->Grd=1;
      *numsgn+=1;
    }
//    c->Num=cnt;
    cnt+=1;
    c=c->next;
  }

  if ((*numgrd == cnt) && (cnt != 1)){
    printf("ERROR: No signal line?\n\n\n");
    exit(1);
  }
  if ((*numgrd == 0) && (cnt != 1)){
    printf("ERROR: No ground line?\n\n\n");
    exit(1);
  }
  return wgrd;
}
     

void filplane(Conductor *c)
{
  FILE *fo;
  fo=fopen("plate","w");
  double **UX;
  double **LX;
  UX=dmatrix(sis->pc+2,4*sis->lc+4);
  LX=dmatrix(sis->pc+2,4*sis->lc+4);
  double *x1,*x2,*y1,*y2;
  x1=new double[sis->pc+1]; 
  x2=new double[sis->pc+1];
  y1=new double[sis->pc+1];
  y2=new double[sis->pc+1]; 
  int j,i,k;
  struct line line[sis->lc+1];
  struct Plane Plane[sis->pc+2];
  for (i=0;i<=sis->lc;i++) line[i].h1=line[i].h2=0.;
  i=1; j=1;
  double *sort;
  sort=new double[sis->pc+1];
  while (c != NULL) {
    if (c->lp==1) {
      line[i].x1=c->x1;
      line[i].x2=c->x2;
      line[i].y1=c->y1; 
      line[i].y2=c->y2;
      c->dx=1;
      c->dy=1;
      c->surf=3;
      i++;
    }
    else if (c->lp==0) {
      x1[j]=c->x1;
      x2[j]=c->x2;
      y1[j]=c->y1;
      y2[j]=c->y2;
      c->surf=3;
      j++;
    }
    else {
      line[i].x1=c->xc-c->rad;
      line[i].x2=c->xc+c->rad;
      line[i].y1=c->yc-c->rad;
      line[i].y2=c->yc+c->rad;
      c->surf=10;
      i++;
    }
    c=c->next;
  }
  double temp; 
  for (i=1;i<=sis->pc;i++) sort[i]=y1[i];
  b_bubble(sort,sis->pc);
  for (i=1;i<=sis->pc;i++) {
    for (j=1;j<=sis->pc;j++) {
      if (sort[i]==y1[j]) {
        Plane[i].x1=x1[j];
        Plane[i].x2=x2[j];
        Plane[i].y1=y1[j];
        Plane[i].y2=y2[j];
      }
    }
  }

  //determining position of each line
  for (i=1;i<=sis->lc;i++) {
    k=0;
    for (j=1;j<=sis->pc;j++) 
	if (line[i].y1 < Plane[j].y1) k++;
    line[i].pos=k+1;
  }
  //assign distance from line to plane
  for (i=1;i<=sis->lc;i++) {
    if ((line[i].pos!=1)&&(line[i].pos!=(sis->pc+1))) {
      line[i].h1=geth(line[i].y1,line[i].y2,Plane[line[i].pos-1].y1
	,Plane[line[i].pos-1].y2);
      line[i].h2=geth(line[i].y1,line[i].y2,Plane[line[i].pos].y1
	,Plane[line[i].pos].y2);
    }
    else if (line[i].pos==1) {
      line[i].h1=0.;
      line[i].h2=geth(line[i].y1,line[i].y2,Plane[1].y1,Plane[1].y2);
    }
    else if (line[i].pos==(sis->pc+1)) {
      line[i].h1=geth(line[i].y1,line[i].y2,Plane[sis->pc].y1,
	Plane[sis->pc].y2);
      line[i].h2=0.;
    }
  }
  int *u; 
  u=new int[sis->lc+3];
  int *l;
  l=new int[sis->lc+3]; 
  for (i=1;i<=sis->lc+2;i++) u[i]=l[i]=0;
  
  for (i=1;i<=sis->lc;i++) {
    if (line[i].h2!=0.) { 
      UX[line[i].pos][u[line[i].pos]+1]=line[i].x1;
      UX[line[i].pos][u[line[i].pos]+2]=line[i].x2;
      u[line[i].pos]+=2;
    }
  }
  for (i=1;i<=sis->lc;i++) {
    if (line[i].h1!=0) {
      LX[line[i].pos-1][l[line[i].pos-1]+1]=line[i].x1;
      LX[line[i].pos-1][l[line[i].pos-1]+2]=line[i].x2;
      l[line[i].pos-1]+=2;
    }
  }
  for (i=1;i<=sis->pc;i++) {
    LX[i][l[i]+1]=Plane[i].x1;
    LX[i][l[i]+2]=Plane[i].x2;
    UX[i][u[i]+1]=Plane[i].x1;
    UX[i][u[i]+2]=Plane[i].x2;
    l[i]+=2; u[i]+=2;
  }  
  double *a,*b;
  a=new double[3*sis->lc+4]; 
  b=new double[3*sis->lc+4];
  for (i=1;i<=sis->pc;i++) {
    for (j=1;j<=u[i];j++) a[j]=UX[i][j];
    for (j=1;j<=l[i];j++) b[j]=LX[i][j]; 
    bubble(a,u[i]);
    for (j=1;j<=u[i];j++) UX[i][j]=a[j];
    bubble(b,l[i]);
    for (j=1;j<=l[i];j++) LX[i][j]=b[j];
  }

  struct space su[sis->pc+1][sis->lc+2];
  struct space sl[sis->pc+1][sis->lc+2];
  for (i=1;i<=sis->pc;i++) {
    for (j=1;j<=u[i]/2;j++) su[i][j].hl=su[i][j].hr=0.;
    for (j=1;j<=l[i]/2;j++) sl[i][j].hl=sl[i][j].hr=0.;
  }
  for (i=1;i<=sis->pc;i++) {
    for (j=1;j<=(u[i]/2);j++) {
      su[i][j].xl=UX[i][2*j-1];
      su[i][j].xr=UX[i][2*j];
    }
    for (j=1;j<=(l[i]/2);j++) {
      sl[i][j].xl=LX[i][2*j-1];    
      sl[i][j].xr=LX[i][2*j]; 
    }    
  } 
  const double small=1e-9;
  double temp1,temp2,temp3,temp4;
  //assigning height on each space
  for (k=1;k<=sis->pc;k++) {
    for (j=1;j<=(u[k]/2);j++) {
      for (i=1;i<=sis->lc;i++) {
        temp1=fabs(line[i].x2-su[k][j].xl);
        if (temp1 < small) {
          su[k][j].hl=line[i].h2;
        }
        temp2=fabs(line[i].x1-su[k][j].xr);
        if (temp2 < small) su[k][j].hr=line[i].h2;
      }
    }
  }
   for (k=1;k<=sis->pc;k++) {   
     for (j=1;j<=(l[k]/2);j++) {
       for (i=1;i<=sis->lc;i++) { 
        temp1=fabs(line[i].x2-sl[k][j].xl);  
        if (temp1 < small) sl[k][j].hl=line[i].h1;
        temp2=fabs(line[i].x1-sl[k][j].xr); 
        if (temp2 < small) sl[k][j].hr=line[i].h1; 
      }
    }
  }
  for (i=1;i<=sis->pc;i++) {
    k=u[i]; 
    for (j=1;j<=k/2;j++) {
      temp1=3.1*(su[i][j].hr+su[i][j].hl);
      temp2=fabs(su[i][j].xr-su[i][j].xl);
      if ((su[i][j].hr==0.)||(su[i][j].hl==0.)) {
        if ((su[i][j].hr!=0.)||(su[i][j].hl!=0.)) {
        if (temp1 < temp2) {
          if (su[i][j].hl==0.) {
            UX[i][u[i]+1]=su[i][j].xr-temp1; 
            u[i]++;
          }
          else if (su[i][j].hr==0.) {
            UX[i][u[i]+1]=su[i][j].xl+temp1;
            u[i]++;
          }
        }
        }
      }
      else {
        if (temp1 < temp2) {
          UX[i][u[i]+1]=su[i][j].xl+3.1*su[i][j].hl; 
          UX[i][u[i]+2]=su[i][j].xr-3.1*su[i][j].hr;
          u[i]+=2;
        }
        else if ((temp1 >= temp2)&&((temp2 >= 3.1*su[i][j].hl)||
	(temp2 >= 3.1*su[i][j].hr))) {
          UX[i][u[i]+1]=su[i][j].xl+fabs(su[i][j].xl-su[i][j].xr)*su[i][j].hl
	/(temp1/3.);
          u[i]++;
        }
      }
    }
  }

  for (i=1;i<=sis->pc;i++) {
    k=l[i];
    for (j=1;j<=k/2;j++) {
      temp1=3.1*(sl[i][j].hr+sl[i][j].hl);
      temp2=fabs(sl[i][j].xr-sl[i][j].xl);
      if ((sl[i][j].hr==0.)||(sl[i][j].hl==0.)) {
        if ((sl[i][j].hr!=0.)||(sl[i][j].hl!=0.)) {
        if (temp1 < temp2) {
          if (sl[i][j].hl==0.) {
            LX[i][l[i]+1]=sl[i][j].xr-temp1;
            l[i]++;
          }
          else if (sl[i][j].hr==0.) {
            LX[i][l[i]+1]=sl[i][j].xl+temp1;
            l[i]++;
          }
        }
        }
      }
      else {
        if (temp1 < temp2) {
          LX[i][l[i]+1]=sl[i][j].xl+3.*sl[i][j].hl;
          LX[i][l[i]+2]=sl[i][j].xr-3.*sl[i][j].hr;
          l[i]+=2;
        }
        else if ((temp1 >= temp2)&&((temp2 >= 3.1*sl[i][j].hl)||
	(temp2 >= 3.1*sl[i][j].hr))) {
          LX[i][l[i]+1]=sl[i][j].xl+fabs(sl[i][j].xl-sl[i][j].xr)*sl[i][j].hl
	/(temp1/3.);
          l[i]++;
        }
      }
    }
  }
  for (i=1;i<=sis->pc;i++) {
    for (j=1;j<=u[i];j++) a[j]=UX[i][j];
    bubble(a,u[i]);
    for (j=1;j<=u[i];j++) UX[i][j]=a[j];
    for (j=1;j<=l[i];j++) b[j]=LX[i][j];
    bubble(b,l[i]);
    for (j=1;j<=l[i];j++) LX[i][j]=b[j];
  }
  for (i=1;i<=sis->pc;i++) {
    for (j=1;j<=l[i];j++) {
      if (l[i]!=2) 
	if (LX[i][j]!=LX[i][j+1])  fprintf(fo,"below %ld %le\n",i,LX[i][j]);
    } 
    for (j=1;j<=u[i];j++) {
     if (u[i]!=2) 
	if (UX[i][j]!=UX[i][j+1]) fprintf(fo,"above %ld %le\n",i,UX[i][j]);
    }
  }

  delete c;
  delete l;
  delete a;
  delete b;
  fclose(fo);
}



