/* Reading Input Geometry */
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include "weeks.h"
#include "linklist.h"
//#define _tolower(c) ((c)+ 'a' - 'A')


void tolowercase(char* st)
{
  while(*st != '\0') {
    *st = tolower(*st);
    st++;
  }
}


void Default(Conductor* c)
{
    c->rx=1.; c->ry=1.; c->dx=5; c->dy=5;
    c->surf=4;
    c->v=1; c->si=5.8*1e7;
    c->nr=10;
    c->x1=0.; c->x2=0.; c->y1=1; c->y2=1.;
    c->xc=0; c->yc=0;
}

void ReadRest(Sys *sis,Conductor* conduc,fstream& fl,int& line)
{
  char* s1;
  char *proj;
 
  proj=new char[80];

  char dum;
  double dummy;
  Default(conduc);
  s1=new char[20];
  fl >> s1; 
  tolowercase(s1);
  while (strcmp(s1,"}")!=0) {
    if (strncmp(s1,"*",1)==0) continue;
    else if (strcmp(s1,"type=")==0) {
      fl >> s1; 
      tolowercase(s1);
      if (strcmp(s1,"tl")==0) conduc->surf=4;
      else if (strcmp(s1,"pw")==0) conduc->surf=3;
      else if (strcmp(s1,"vf")==0) conduc->surf=5;
    }
    else if (strcmp(s1,"type")==0) {
      fl >> s1; 
      tolowercase(s1);
      if (strcmp(s1,"=")==0) {
        fl >> s1;
        tolowercase(s1);
        if (strcmp(s1,"tl")==0) conduc->surf=4;
        else if (strcmp(s1,"pw")==0) conduc->surf=3;
        else if (strcmp(s1,"vf")==0) conduc->surf=5;
      }
      else {
        if (strcmp(s1,"=tl")==0) conduc->surf=4;
        else if (strcmp(s1,"=pw")==0)  conduc->surf=3;
        else if (strcmp(s1,"=vf")==0)  conduc->surf=5;
      }
    }
    else if (strcmp(s1,"type=tl")==0) conduc->surf=4;
    else if (strcmp(s1,"type=pw")==0) conduc->surf=3;
    else if (strcmp(s1,"type=vf")==0) conduc->surf=5;
    else if (strcmp(s1,"rx=")==0) fl >> conduc->rx;
    else if (strcmp(s1,"rx")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) fl >> conduc->rx;
      else sscanf(s1,"%c%le",&dum,&conduc->rx);
    }
    else if (strcmp(s1,"ry=")==0) fl >> conduc->ry;
    else if (strcmp(s1,"ry")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) fl >> conduc->ry;
      else sscanf(s1,"%c%le",&dum,&conduc->ry);
    }
    else if (strcmp(s1,"x1=")==0) {
      fl >> dummy;
      conduc->x1=dummy*sis->unit;
    }
    else if (strcmp(s1,"x1")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) {
        fl >> dummy;
        conduc->x1=dummy*sis->unit;
      }
      else {
        sscanf(s1,"%c%le",&dum,&dummy);
        conduc->x1=dummy*sis->unit;
      }
    } 
    else if (strcmp(s1,"x2=")==0) {
      fl >> dummy;
      conduc->x2=dummy*sis->unit;
    }
    else if (strcmp(s1,"x2")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) {
        fl >> dummy;
        conduc->x2=dummy*sis->unit;
      }
      else {
        sscanf(s1,"%c%le",&dum,&dummy);
        conduc->x2=dummy*sis->unit;
      }
    }
    else if (strcmp(s1,"y1=")==0) {
      fl >> dummy;
      conduc->y1=dummy*sis->unit;
    }
    else if (strcmp(s1,"y1")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) {
        fl >> dummy;
        conduc->y1=dummy*sis->unit;
      }
      else {
        sscanf(s1,"%c%le",&dum,&dummy);
        conduc->y1=dummy*sis->unit;
      }
    }
    else if (strcmp(s1,"y2=")==0) {
      fl >> dummy;
      conduc->y2=dummy*sis->unit;
    }
    else if (strcmp(s1,"y2")==0) {
      fl >> s1;  
      if (strcmp(s1,"=")==0) {
        fl >> dummy;
        conduc->y2=dummy*sis->unit;
      }
      else {
        sscanf(s1,"%c%le",&dum,&dummy);
        conduc->y2=dummy*sis->unit;
      }
    }
    else if (strcmp(s1,"xc=")==0) {
      fl >> dummy;
      conduc->xc=dummy*sis->unit;
    }
    else if (strcmp(s1,"xc")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) {
        fl >> dummy;
        conduc->xc=dummy*sis->unit;
      }
      else {
        sscanf(s1,"%c%le",&dum,&dummy);
        conduc->xc=dummy*sis->unit;
      }
    }
    else if (strcmp(s1,"yc=")==0) {
      fl >> dummy;
      conduc->yc=dummy*sis->unit;
    }
    else if (strcmp(s1,"yc")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) {
        fl >> dummy;
        conduc->yc=dummy*sis->unit;
      }
      else {
        sscanf(s1,"%c%le",&dum,&dummy);
        conduc->yc=dummy*sis->unit;
      }
    }
    else if (strcmp(s1,"rad=")==0) {
      fl >> dummy;
      conduc->rad=dummy*sis->unit;
    }
    else if (strcmp(s1,"rad")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) {
        fl >> dummy;
        conduc->rad=dummy*sis->unit;
      }
      else {
        sscanf(s1,"%c%le",&dum,&dummy);
        conduc->rad=dummy*sis->unit;
      }
    }
    else if (strcmp(s1,"v=")==0) fl >> conduc->v;
    else if (strcmp(s1,"v")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) fl >> conduc->v;
      else sscanf(s1,"%c%le",&dum,&conduc->v);
    }
    else if (strcmp(s1,"sigma=")==0) {
      fl >> dummy;
      conduc->si=dummy/sis->unit;
    }
    else if (strcmp(s1,"sigma")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) {
        fl >> dummy;
        conduc->si=dummy/sis->unit;
      }
      else {
        sscanf(s1,"%c%le",&dum,&dummy);
        conduc->si=dummy/sis->unit;
      }
    }
    else if (strcmp(s1,"nx=")==0) fl >> conduc->dx;
    else if (strcmp(s1,"nx")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) fl >> conduc->dx;
      else sscanf(s1,"%c%ld",&dum,&conduc->dx);
    }
    else if (strcmp(s1,"ny=")==0) fl >> conduc->dy;
    else if (strcmp(s1,"ny")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) fl >> conduc->dy;
      else sscanf(s1,"%c%ld",&dum,&conduc->dy);
    }
    else if (strcmp(s1,"nr=")==0) fl >> conduc->nr;
    else if (strcmp(s1,"nr")==0) {
      fl >> s1;
      if (strcmp(s1,"=")==0) fl >> conduc->nr;
      else sscanf(s1,"%c%ld",&dum,&conduc->nr);
    }
    else  if ((strncmp(s1,"*",1)==0)||(strncmp(s1,".",1)==0)) {
      fl.getline(proj,80,'\n');
    }
    else {
      if (strncmp(s1,"x1=",3)==0) {
	sscanf(s1,"%c%c%c%le",&dum,&dum,&dum,&dummy);
	conduc->x1=dummy*sis->unit;
      }
      else if (strncmp(s1,"x2=",3)==0) {
	sscanf(s1,"%c%c%c%le",&dum,&dum,&dum,&dummy);
	conduc->x2=dummy*sis->unit;
      }
      else if (strncmp(s1,"y1=",3)==0) {
	sscanf(s1,"%c%c%c%le",&dum,&dum,&dum,&dummy);
	conduc->y1=dummy*sis->unit;
      }
      else if (strncmp(s1,"y2=",3)==0) {
	sscanf(s1,"%c%c%c%le",&dum,&dum,&dum,&dummy);
	conduc->y2=dummy*sis->unit;
      }
      else if (strncmp(s1,"xc=",3)==0) {
        sscanf(s1,"%c%c%c%le",&dum,&dum,&dum,&dummy);
        conduc->xc=dummy*sis->unit;
      }
      else if (strncmp(s1,"yc=",3)==0) {
        sscanf(s1,"%c%c%c%le",&dum,&dum,&dum,&dummy);
        conduc->yc=dummy*sis->unit;
      }
      else if (strncmp(s1,"rad=",4)==0) {
        sscanf(s1,"%c%c%c%c%le",&dum,&dum,&dum,&dum,&dummy);
        conduc->rad=dummy*sis->unit;
      }
      else if (strncmp(s1,"sigma=",6)==0) {
	sscanf(s1,"%c%c%c%c%c%c%le",&dum,&dum,&dum,&dum,&dum,&dum,&dummy);
	conduc->si=dummy/sis->unit;
      }
      else if (strncmp(s1,"v=",2)==0)
	sscanf(s1,"%c%c%le",&dum,&dum,&conduc->v);
      else if (strncmp(s1,"nx=",3)==0)
	sscanf(s1,"%c%c%c%ld",&dum,&dum,&dum,&conduc->dx);
      else if (strncmp(s1,"ny=",3)==0)
	sscanf(s1,"%c%c%c%ld",&dum,&dum,&dum,&conduc->dy);
      else if (strncmp(s1,"nr=",3)==0)
	sscanf(s1,"%c%c%c%ld",&dum,&dum,&dum,&conduc->nr);
      else if (strncmp(s1,"rx=",3)==0)
	sscanf(s1,"%c%c%c%le",&dum,&dum,&dum,&conduc->rx);
      else if (strncmp(s1,"ry=",3)==0)
	sscanf(s1,"%c%c%c%le",&dum,&dum,&dum,&conduc->ry);
//      else {
//        cerr << "Error occured during Reading Input please check 
//	the input file!"  << "\n";
//        exit(1);
//      }
    }
    fl >> s1;
    tolowercase(s1);
  }
  delete s1;
  return;
}

void reader(Conductor* conduc,Sys* sis,char* fn)
{
  char *proje,*ss,*s1;
  double c;
  int line;

  proje=new char[80];
  ss=new char[80];
  s1=new char[80];

  fstream fll(fn,ios::in);
  if (!fll) {
    exit(1);
  }
  line=0;
  sis->unit=1.;
  sis->loop=0;
  do {
    fll >> ss;
    tolowercase(ss);
    if (strcmp(ss,".freq")==0) { 
      fll >> sis->stFreq >> sis->spFreq >> sis->NofF;  
      line=100;
    }
    else if (strcmp(ss,".unit")==0) {
      fll >> ss;
      tolowercase(ss);
      if (strcmp(ss,"m")==0) sis->unit=1.;
      else if (strcmp(ss,"mm")==0) sis->unit=1e-3;
      else if (strcmp(ss,"cm")==0) sis->unit=1e-2;
      else if (strcmp(ss,"in")==0) sis->unit=2.54*1e-2;
      else if (strcmp(ss,"um")==0) sis->unit=1e-6;
      else if (strcmp(ss,"mils")==0) sis->unit=2.54*1e-5;
      else if (strcmp(ss,"ft")==0) sis->unit=0.3048;
      else sis->unit=1.;
    }
    else if (strcmp(ss,".partial")==0) {
      fll >> ss;
      tolowercase(ss);
      if ((strcmp(ss,"yes")==0)|| (strcmp(ss,"y")==0))  sis->loop=1;
      else if ((strcmp(ss,"no")==0)|| (strcmp(ss,"n")==0)) sis->loop=0;
    }
  }while(strcmp(ss,"end")!=0);   
  if (line!=100) printf(".freq is missing!\n");

  fll.clear();
  delete ss;
  ss=new char[100];
  int p_c,l_c;
  p_c=0; l_c=0;
  fstream fl(fn,ios::in);
  line=0;
  do {
    fl >> ss;
    tolowercase(ss);
    if (strncmp(ss,"*",1)==0)  {
      fl.getline(proje,80,'\n');
    }
    else if ((strcmp(ss,"line")==0)||(strcmp(ss,"line{")==0)) {
      conduc->lp=1;
      l_c++;
    }
    else if ((strcmp(ss,"circle")==0)||(strcmp(ss,"circle{")==0)) {
      conduc->lp=2;
      l_c++;
    }
    else if ((strcmp(ss,"plate")==0)||(strcmp(ss,"plate{")==0)) {
      conduc->lp=0;
      p_c++; 
    }
  }while ((strcmp(ss,"{")!=0)&&(strcmp(ss,"line{")!=0)&&
	(strcmp(ss,"plate{")!=0)&&(strcmp(ss,"circle{")!=0)); 
  

  do {
    ReadRest(sis,conduc,fl,line);
    fl >> ss;
    tolowercase(ss);
    if (strcmp(ss,"end")==0) {
      delete ss;
      delete s1;
      sis->pc=p_c;
      sis->lc=l_c;
      fl.clear();
      return;
    }
    if ((strncmp(ss,"*",1)==0)||(strncmp(ss,".",1)==0)) {
      fl.getline(proje,80,'\n');
      do {
        fl >> ss;
        tolowercase(ss);
        if ((strcmp(ss,"plate")==0)||(strcmp(ss,"plate{")==0)) {
          newCon(conduc);
          conduc = conduc->next;
          conduc->lp=0;
          if (strcmp(ss,"plate")==0) {
            fl >> ss;
           }
          p_c++;
        }
        else if ((strcmp(ss,"line")==0)||(strcmp(ss,"line{")==0)) {
          newCon(conduc);
          conduc = conduc->next;
          conduc->lp=1;
          if (strcmp(ss,"line")==0) {
            fl >> ss;
          }
          l_c++;
        }
        else if ((strcmp(ss,"circle")==0)||(strcmp(ss,"circle{")==0)) {
          newCon(conduc);
          conduc = conduc->next;
          conduc->lp=2;
          if (strcmp(ss,"circle")==0) {
            fl >> ss;
          }
          l_c++;
        }
        else if ((strncmp(ss,"*",1)==0)||(strncmp(ss,".",1)==0)) 
	fl.getline(proje,80,'\n');
      }while ((strcmp(ss,"{")!=0)&&(strcmp(ss,
	"plate{")!=0)&&(strcmp(ss,"line{")!=0)&&(strcmp(ss,"circle{")!=0)); 
    }
    else if ((strcmp(ss,"line")==0)||(strcmp(ss,"line{")==0)) {
      newCon(conduc);
      conduc = conduc->next;
      conduc->lp=1;
      if (strcmp(ss,"line")==0) fl >> ss;
      l_c++;
    }
    else if ((strcmp(ss,"circle")==0)||(strcmp(ss,"circle{")==0)) {
      newCon(conduc);
      conduc = conduc->next;
      conduc->lp=2;
      if (strcmp(ss,"circle")==0) fl >> ss;
      l_c++;
    }
    else if ((strcmp(ss,"plate")==0)||(strcmp(ss,"plate{")==0)) {
      newCon(conduc);
      conduc = conduc->next;
      conduc->lp=0;
      p_c++;
      if (strcmp(ss,"plate")==0) {
        fl >> ss;
      }
    }
    else {
      printf("error occur during reading input\n");
      exit(1);
    }
  }while (strcmp(ss,"end")!=0);
}
