/* This part determines ribbon segmentation */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>
#include "weeks.h"
#include "linklist.h"
#include "nonuni.h"
#define PI M_PI
extern Sys *sis;

Filament* surfer(Conductor* cc,Filament* f,int &is,int posi)
{
  double *UX=new double[4*sis->lc+4];
  double *LX=new double[4*sis->lc+4];
  double SLABTHICK;
  int u,l,d,cnt;
  double dum;
  l=0; u=0;
  if ((cc->lp==0)&&(sis->pc!=0)) {
    fstream plate("plate",ios::in);
    char *ss;
    ss=new char[100];
    do {
      plate >> ss >> d;
      if ((strcmp(ss,"below")==0)&&(d==posi)) {
        l++;
        plate >> LX[l] ;
      }
      else if ((strcmp(ss,"above")==0)&&(d==posi)) {
        u++;
        plate >> UX[u];
      }
      else plate >> dum;
    }while ((strcmp(ss,"above")==0)||(strcmp(ss,"below")==0)); 
    plate.clear();
    delete ss;
  }

  double t,w,delx,dely,st,x,dx,dy,oldy,phi,oldx;
  int nc,ns,i,n;
  double maxf,skin;
  maxf=sis->spFreq;
  skin=1/sqrt(PI*maxf*4*PI*cc->si*1e-7);

  if (cc->lp != 2) {
    if ((delx=fabs(cc->x2-cc->x1)) > (dely=fabs(cc->y2-cc->y1))) {
      t=dely;
      w=delx;
    }
    else {
      t=delx;
      w=dely;
    }
  }
  if (cc->lp==2) SLABTHICK=0.;
  else SLABTHICK=1e-4;

  if (cc->lp==0) {  /* plate */
    for (i=1;i<l;i++) {
      f->parent=cc;
      if (u!=0) f->pos=3;
      else f->pos=2;
      f->x1=LX[i];
      f->x2=LX[i+1];
      f->y1=cc->y1;
      f->y2=f->y1+delx*SLABTHICK;
      newFil(f);
      f=f->next;
      is++;
    }
    for (i=1;i<u;i++) {
      f->parent=cc;
      if (l!=0) f->pos=3;
      else f->pos=2;
      f->x1=UX[i];
      f->x2=UX[i+1];
      f->y1=cc->y2;
      f->y2=f->y1-delx*SLABTHICK;
      newFil(f);
      f=f->next;
      is++;
    }
    delete UX;
    delete LX;
  }
  else if (cc->lp==1) { /* just line */
    if ((skin > fabs(cc->x2-cc->x1)) && (skin > fabs(cc->y2-cc->y1))) {
      f->parent=cc;
      f->pos=20;
      f->x1=cc->x1;
      f->x2=cc->x2;
      f->y1=cc->y1;
      f->y2=cc->y2;
      newFil(f);
      f=f->next;
      is++;
    }
    else if (cc->surf==5) {
      delx=fabs(cc->x2-cc->x1)/cc->dx;
      dely=fabs(cc->y2-cc->y1)/cc->dy; 
      int j;
      for (i=0 ; i<cc->dy; i++) {
        oldy=i*dely;
        for (j=0; j<cc->dx; j++) { 
          oldx=j*delx;
          f->parent=cc;
          f->pos=20;
          f->x1=oldx+cc->x1;
          f->x2=f->x1+delx;
          f->y1=oldy+cc->y1;
          f->y2=f->y1+dely;
          newFil(f);
          f=f->next;
          is++;
        }
      }
    }
    else {
      // Lower face:
      double* nonu = new double[cc->dx];    
      dx=fill_nonu(nonu,cc->dx,cc->rx);
      st=(cc->x2-cc->x1)/dx;
      oldy=cc->x1;
      for (i=0 ; i < cc->dx ; i++) {
        f->parent=cc;
        if (cc->dx==1) f->pos=4;
        else f->pos=0;
        f->x1=oldy;
        f->x2=(oldy=f->x1+nonu[i]*st);
        f->y1=cc->y1;
        f->y2=f->y1+delx*SLABTHICK;
        newFil(f);
        f=f->next;
        is++;
      }


    //Upper Face
      oldy=cc->x1;
      for (i=0 ; i < cc->dx ; i++) {
        f->parent=cc;
        if (cc->dx==1) f->pos=4;
        else f->pos=0;
        f->x1=oldy;
        f->x2=(oldy=f->x1+nonu[i]*st);
        f->y1=cc->y2;
        f->y2=f->y1+delx*SLABTHICK;
        newFil(f);
        f=f->next;
        is++;
      }
      delete nonu;
  
    //Left Face
      nonu=new double[cc->dy];
      dy=fill_nonu(nonu,cc->dy,cc->ry);
      st=(cc->y2-cc->y1)/dy;
      oldy=cc->y1;
      for (i=0 ; i < cc->dy ; i++) {
        f->parent=cc;
        if (cc->dx==1) f->pos=5;
        else f->pos=1;
        f->y1=oldy;
        f->y2=(oldy=f->y1+nonu[i]*st);
        f->x1=cc->x1;
        f->x2=f->x1+delx*SLABTHICK;
        newFil(f);
        f=f->next;
        is++;
      }

    //Right Face
      oldy=cc->y1;
      for (i=0 ; i < cc->dy ; i++) {
        f->parent=cc;
        if (cc->dx==1) f->pos=5;
        else f->pos=1;
        f->y1=oldy;
        f->y2=(oldy=f->y1+nonu[i]*st);
        f->x1=cc->x2;
        f->x2=f->x1+delx*SLABTHICK;
        newFil(f);
        f=f->next;
        is++;
      }
    delete nonu;
    }
  }
  else if (cc->lp==2) { /*circle */
    phi=double(2*PI/cc->nr);
    cnt=0;
    for (i=0; i < cc->nr; i++) {
      f->parent=cc;
      f->pos=10;
      f->x1=(cc->rad*cos(i*phi)+cc->xc);
      f->x2=(cc->rad*cos((i+1.)*phi)+cc->xc);
      f->y1=(cc->rad*sin(i*phi)+cc->yc);
      f->y2=(cc->rad*sin((i+1.)*phi)+cc->yc);
      f->num=cnt;
      newFil(f);
      f=f->next;
      is++;
      cnt++;
    }
  }
  return f;
}

